Bidirectional Forwarding Detection (BFD) for Multipoint Networks over Point-to-Multipoint MPLS Label Switched Paths (LSPs)
RFC 9780
Greg Mirsky
Ericsson
gregimirsky@gmail.com
Gyan Mishra
Verizon Inc.
gyan.s.mishra@verizon.com
Donald Eastlake 3rd
Independent
2386 Panoramic Circle
Apopka
FL
32703
United States of America
d3e3e3@gmail.com
May 2025
RTG
mpls
BFD
Multipoint LSP
This document describes procedures for using Bidirectional Forwarding Detection (BFD) for multipoint networks to detect data plane failures in point-to-multipoint MPLS Label Switched Paths (LSPs) and Segment Routing (SR) point-to-multipoint policies with an SR over MPLS (SR-MPLS) data plane.
Furthermore, this document updates RFC 8562 by recommending the use of an IPv6 address from the Dummy IPv6 Prefix address block 100:0:0:1::/64 and discouraging the use of an IPv4 loopback address mapped to IPv6.
In addition, this document describes the applicability of LSP Ping (as an in-band solution) and the control plane (as an out-of-band solution) to bootstrap a BFD session. The document also describes the behavior of the active tail for head notification.
Introduction
[RFC8562] defines a method of using Bidirectional Forwarding Detection (BFD) [RFC5880] to monitor and detect failures between the sender (head) and one or more receivers (tails) in multipoint or multicast networks.
[RFC8562] added two BFD session types: MultipointHead and MultipointTail. Throughout this document, MultipointHead and MultipointTail refer to the value to which the bfd.SessionType is set on a BFD endpoint.
This document describes procedures for using such modes of the BFD protocol to detect data plane failures in point-to-multipoint (P2MP) MPLS Label Switched Paths (LSPs) and Segment Routing (SR) point-to-multipoint policies with an SR over MPLS (SR-MPLS) data plane.
The document also describes the applicability of LSP Ping (an in-band solution) and out-of-band solutions to bootstrap a BFD session in this environment.
Historically, an address in the IPv6-mapped IPv4 loopback address block ::ffff:127.0.0.1/128 was mandated, although functionally, an IPv6 address from that address block is not analogous to its IPv4 counterpart. Furthermore, using the loopback address as the destination address, even for an inner IP encapsulation of a tunneled packet, violates Section 2.5.3 of [RFC4291]. Hence, IANA has allocated 100:0:0:1::/64 as a new Dummy IPv6 Prefix (Section 7.1) for destination IPv6 addresses used for IP/UDP encapsulation of management, control, and OAM (Operations, Administration, and Maintenance) packets. A source-only IPv6 dummy address is used as the destination to generate an exception and a reply message to the request message received. This document starts the transition to using the IPv6 addresses from the Dummy IPv6 Prefix address block 100:0:0:1::/64 as the IPv6 destination address in the IP/UDP encapsulation of active OAM over the MPLS data plane. Thus, this document updates [RFC8562] by recommending the use of an IPv6 address from the Dummy IPv6 Prefix address block 100:0:0:1::/64 (Section 7.1) while acknowledging that an address from the ::ffff:127.0.0.1/128 address block might be used by existing implementations. This document discourages the use of an address in the IPv6-mapped IPv4 loopback address block.
This document also describes the behavior of the active tail for head notification.
Conventions Used in This Document
Terminology
ACH:
Associated Channel Header
BFD:
Bidirectional Forwarding Detection
GAL:
G-ACh Label
G-ACh:
Generic Associated Channel
LSP:
Label Switched Path
LSR:
Label Switching Router
MPLS:
Multiprotocol Label Switching
P2MP:
Point-to-Multipoint
PW:
Pseudowire (PW)
SR:
Segment Routing
SR-MPLS:
SR over MPLS
Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
Multipoint BFD Encapsulation
[RFC8562] uses BFD in Demand mode from the very start of a point-to-multipoint (P2MP) BFD session. Because the head doesn't receive any BFD Control packets from a tail, the head of the P2MP BFD session transmits all BFD Control packets with the value of the Your Discriminator field set to zero. As a result, a tail cannot demultiplex BFD sessions using Your Discriminator, as defined in [RFC5880]. To demultiplex BFD sessions, [RFC8562] requires that the tail use the source IP address, My Discriminator, and the identity of the multipoint tree from which the BFD Control packet was received. If the BFD Control packet is encapsulated in IP/UDP, then the source IP address MUST be used to demultiplex the received BFD Control packet as described in Section 5.7 of [RFC8562]. The non-IP encapsulation case is described in Section 3.2.
IP Encapsulation of Multipoint BFD
[RFC8562] defines IP/UDP encapsulation for multipoint BFD over P2MP MPLS LSP. This document updates Section 5.8 of [RFC8562] regarding the selection of the IPv6 destination address as follows:
- The sender of an MPLS echo request SHOULD use an address from the Dummy IPv6 Prefix address block 100:0:0:1::/64 (see Section 7.1).
- The sender of an MPLS echo request MAY select the IPv6 destination address from the ::ffff:7f00/104 address block.
Section 1.2 of [RFC6790] lists several advantages of generating the entropy value by an ingress Label Switching Router (LSR) compared to when a transit LSR infers entropy using the information in the MPLS label stack or payload. This specification further clarifies the following if multiple alternative paths for the given P2MP LSP Forwarding Equivalence Class (FEC) exist:
- The MultipointHead SHOULD use the Entropy Label [RFC6790] used for LSP Ping [RFC8029] to exercise those particular alternative paths; or
- The MultipointHead MAY use the UDP port number to possibly exercise those particular alternate paths.
Non-IP Encapsulation of Multipoint BFD
In some environments, the overhead of extra IP/UDP encapsulations may be considered burdensome, which makes the use of more compact Generic Associated Channel (G-ACh) [RFC5586] encapsulation attractive. Also, the validation of the IP/UDP encapsulation of a BFD Control packet in a P2MP BFD session may fail because of a problem related to neither the MPLS label stack nor BFD. Avoiding unnecessary encapsulation of P2MP BFD over an MPLS LSP improves the accuracy of the correlation of the detected failure and defect in MPLS LSP.
Non-IP encapsulation for multipoint BFD over P2MP MPLS LSP (shown in Figure 1) MUST use the G-ACh Label (GAL) [RFC5586] at the bottom of the label stack followed by an Associated Channel Header (ACH). If a BFD Control packet in PW-ACH encapsulation (without IP/UDP Headers) is to be used in ACH, an implementation would not be able to verify the identity of the MultipointHead and, as a result, will not properly demultiplex BFD packets. Hence, a new channel type value is needed. The Channel Type field in ACH MUST be set to Multipoint BFD Session (0x0013) (see Section 7.2). To provide the identity of the MultipointHead for the particular multipoint BFD session, a Source Address TLV, as defined in Section 4.1 of [RFC7212], MUST immediately follow a BFD Control packet. The use of other TLVs is outside the scope of this document.
Non-IP Encapsulation for Multipoint BFD over a Multicast MPLS LSP

 0                   1                   2                   3
 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|               LSP Label               |  TC |S|       TTL     |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                  GAL                  |  TC |1|       TTL     |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|0 0 0 1|Version|     Flags     |      Channel Type = 0x0013    |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
~                        BFD Control Packet                     ~
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|     Type=0    |    Reserved   |            Length             |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|           Reserved            |         Address Family        |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
~                            Address                            ~
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

The fields in Figure 1 are interpreted as follows:
- The top three four-octet words are defined in [RFC5586].
- The BFD Control Packet field is defined in [RFC5880].
- All the remaining fields are defined in Section 4.1 of [RFC7212].
Bootstrapping Multipoint BFD
LSP Ping
LSP Ping is the part of the on-demand OAM toolset used to detect and localize defects in the data plane and verify the control plane against the data plane by ensuring that the LSP is mapped to the same FEC at both egress and ingress endpoints.
LSP Ping, as defined in [RFC6425], MAY be used to bootstrap MultipointTail. If LSP Ping is used, it MUST include the Target FEC Stack TLV [RFC8029] and the BFD Discriminator TLV [RFC5884]. For the case of P2MP MPLS LSP, the Target FEC Stack TLV MUST use sub-TLVs defined in Section 3.1 of [RFC6425]. For the case of P2MP SR policy with an SR-MPLS data plane, an implementation of this specification MUST follow the procedures defined in [RFC8287]. Setting the value of the Reply Mode field to "Do not reply" [RFC8029] for the LSP Ping to bootstrap the MultipointTail of the P2MP BFD session is RECOMMENDED. Indeed, because BFD over a multipoint network uses BFD Demand mode, the MPLS echo reply from a tail has no useful information to convey to the head, unlike in the case of BFD over a P2P MPLS LSP [RFC5884]. A MultipointTail that receives an LSP Ping that includes the BFD Discriminator TLV MUST do the following:
- validate the LSP Ping;
- associate the received BFD Discriminator value with the P2MP LSP;
- create a P2MP BFD session and set bfd.SessionType = MultipointTail as described in [RFC8562]; and
- use the source IP address of the LSP Ping, the value of BFD Discriminator from the BFD Discriminator TLV, and the identity of the P2MP LSP to properly demultiplex BFD sessions.
Besides bootstrapping a BFD session over a P2MP LSP, LSP Ping SHOULD be used to verify the control plane against the data plane periodically by checking that the P2MP LSP is mapped to the same FEC at the MultipointHead and all active MultipointTails. The rate of generation of these LSP Ping echo request messages SHOULD be significantly less than the rate of generation of the BFD Control packets because LSP Ping requires more processing to validate the consistency between the data plane and the control plane. An implementation MAY provide configuration options to control the rate of generation of the periodic LSP Ping echo request messages.
Control Plane
The BFD Discriminator attribute MAY be used to bootstrap a multipoint BFD session on a tail, following the format and procedures given in Section 3.1.6 of [RFC9026].
Operation of Multipoint BFD with Active Tail over P2MP MPLS LSP
[RFC8562] defines how BFD Demand mode can be used in multipoint networks. When applied in MPLS, the procedures specified in [RFC8562] allow an egress LSR to detect a failure in the part of the P2MP MPLS LSP from the ingress LSR to that egress LSR. The ingress LSR is not aware of the state of the P2MP LSP. [RFC8563], using mechanisms defined in [RFC8562], defines the behavior of an active tail. An active tail might notify the head of the detected failure and respond to a poll sequence initiated by the head. The first method, referred to as "Head Notification without Polling", is mentioned in Section 5.2.1 of [RFC8563]) and is the simplest of the methods described in [RFC8563]. The use of this method in BFD over P2MP MPLS LSP is discussed in this document. Analysis of other methods for a head to learn of the state of the P2MP MPLS LSP is outside the scope of this document.
As specified in [RFC8563], BFD variables MUST be as follows for the active tail mode:
- On an ingress LSR:
  - bfd.SessionType is MultipointHead.
  - bfd.RequiredMinRxInterval is nonzero, allowing egress LSRs to send BFD Control packets.
- On an egress LSR:
  - bfd.SessionType is MultipointTail.
  - bfd.SilentTail is set to zero.
Section 5.2.1 of [RFC8563] notes that "the tail sends unsolicited BFD packets in response to the detection of a multipoint path failure" but does not provide specifics about the information in the packets or the frequency of transmissions. The procedure for an active tail with unsolicited notifications for P2MP MPLS LSP is defined below.
Upon detecting the failure of the P2MP MPLS LSP, an egress LSR sends a BFD Control packet with the following settings:
- The Poll (P) bit is set.
- The Status (Sta) field is set to the Down value.
- The Diagnostic (Diag) field is set to the Control Detection Time Expired value.
- The value of the Your Discriminator field is set to the value the egress LSR has been using to demultiplex that BFD multipoint session.
The BFD Control packet MAY be encapsulated in IP/UDP with the destination IP address of the ingress LSR and the UDP destination port number set to 4784 per [RFC5883]. If non-IP encapsulation is used, then a BFD Control packet is encapsulated using PW-ACH encapsulation (without IP/UDP Headers) with Channel Type 0x0007 [RFC5885].
The BFD Control packets are transmitted at the rate of one per second until either 1) the egress LSA receives a control packet from the ingress LSR that is valid for this BFD session and has the Final (F) bit set or 2) the defect condition clears. However, to improve the likelihood of notifying the ingress LSR of the failure of the P2MP MPLS LSP, the egress LSR SHOULD initially transmit three BFD Control packets (as defined above) in short succession. The actual transmission of the periodic BFD Control packet MUST be jittered by up to 25% within one-second intervals. Thus, the interval MUST be reduced by a random value of 0 to 25%, to reduce the possibility of congestion on the ingress LSR's data and control planes.
As described above, an ingress LSR that has received the BFD Control packet sends the unicast IP/UDP encapsulated BFD Control packet with the Final (F) bit set to the egress LSR. In some scenarios (e.g., when a P2MP LSP is broken close to its root and the number of egress LSRs is significantly large), the root might receive a large number of notifications. The notifications from leaves to the root will not use resources allocated for the monitored multicast flow and, as a result, will not congest that particular flow, although they may negatively affect other flows. However, the control plane of the ingress LSR might be congested by the BFD Control packets transmitted by egress LSRs and the process of generating unicast BFD Control packets, as noted above. To mitigate that, a BFD implementation that supports this specification is RECOMMENDED to use a rate limiter of received BFD Control packets passed to the ingress LSR's control plane for processing.
Security Considerations
This document does not introduce new security considerations but inherits all security considerations from [RFC5880], [RFC5884], [RFC7726], [RFC8562], [RFC8029], and [RFC6425].
Also, BFD for P2MP MPLS LSPs MUST follow the requirements listed in Section 4.1 of [RFC4687] to avoid congestion in the control plane or the data plane caused by the rate of generating BFD Control packets. An operator SHOULD consider the amount of extra traffic generated by P2MP BFD when selecting the interval at which the MultipointHead will transmit BFD Control packets. The operator MAY consider the size of the packet the MultipointHead transmits periodically as using IP/UDP encapsulation, which adds up to 28 octets (more than 50% of the BFD Control packet length) compared to G-ACh encapsulation.
IANA Considerations
IPv6 Special-Purpose Address
IANA has allocated the following in the "IANA IPv6 Special-Purpose Address Registry" [IANA-IPv6-REG]:
Address Block:
100:0:0:1::/64
Name:
Dummy IPv6 Prefix
RFC:
RFC 9780
Allocation Date:
2025-04
Termination Date:
N/A
Source:
True
Destination:
False
Forwardable:
False
Globally Reachable:
False
Reserved-by-Protocol:
False
MPLS Generalized Associated Channel (G-ACh) Type
IANA has allocated the following value in the "MPLS Generalized Associated Channel (G-ACh) Types" registry [IANA-G-ACh-TYPES].
Multipoint BFD Session G-ACh Type
Value | Description | Reference
0x0013 | Multipoint BFD Session | RFC 9780
References
Normative References
Informative References
[IANA-IPv6-REG]

IANA IPv6 Special-Purpose Address Registry
IANA
[IANA-G-ACh-TYPES]

MPLS Generalized Associated Channel (G-ACh) Types
IANA
[RFC8562]
[RFC5880]
[RFC4291]
[RFC2119]
[RFC8174]
[RFC6790]
[RFC8029]
[RFC5586]
[RFC7212]
[RFC6425]
[RFC5884]
[RFC8287]
[RFC9026]
[RFC8563]
[RFC5883]
[RFC5885]
[RFC7726]
[RFC4687]
Acknowledgements
The authors sincerely appreciate the comments received from Andrew Malis, Italo Busi, and Shraddha Hegde. The authors also appreciate the thought-stimulating questions from Carlos Pignataro.